cvs_id = "$Id: LookupManager.py,v 1.2 2003/02/20 12:56:07 juri Exp $"

import straw
import time
import socket
import random
from error import log
import adns, ADNS

class MyQE(ADNS.QueryEngine):
    def lookup_a_record(self, name, callback, extra):
        self.submit(name, adns.rr.A, callback = callback, extra = extra)

class LookupManager:
    namecache = {}
    queryengine = MyQE()
    
    def __init__(self, mintime=86400, maxtime=259200):
        self.mintime = mintime
        self.maxtime = maxtime

    def lookup(self, name, callback, data):
        now = time.time()
        ip = self.namecache.get(name, None)
        expiretime = 0
        if ip is not None:
            ip, expiretime = ip
            if now < expiretime:
                callback(name, ip, data)
                return
        self.queryengine.lookup_a_record(
            name, self.adns_callback, CBWrapper(name, callback, data))
        
    def adns_callback(self, answer, qname, rr, flags, cbwrapper):
        now = int(time.time())
        ips = answer[3]
        if len(ips):
            ip = ips[0]
            self.namecache[qname] = (ip, now + random.randint(
                now+self.mintime, now+self.maxtime))
        else:
            ip = None
        cbwrapper.cb(ip)

    def poll(self, timeout=0.1):
        self.queryengine.run(timeout)

class CBWrapper:
    def __init__(self, name, callback, data):
        self.name = name
        self.data = data
        self.callback = callback

    def cb(self, ip):
        self.callback(self.name, ip, self.data)



  
